<?php
/**
 * Example backend class for a custom address book
 *
 * This one just holds a static list of address records
 *
 * @author Thomas Bruederli
 */
//require_once 'Horde/Kolab/Format/XML.php';
class kaddress_backend extends rcube_addressbook
{
  public $primary_key = 'ID';
  public $readonly = true;
  public $groups = true;

  private $filter;
  private $result;
  private $name;

  public function __construct($name)
  {
    $this->ready = true;
    $this->name = $name;
  }

  public function get_name()
  {
    return $this->name;
  }

  public function set_search_set($filter)
  {
    $this->filter = $filter;
  }

  public function get_search_set()
  {
    return $this->filter;
  }

  public function reset()
  {
    $this->result = null;
    $this->filter = null;
  }

  function list_groups($search = null)
  {
//    return array(
//          array('ID' => 'testgroup1', 'name' => "Test1"),
//      array('ID' => 'testgroup2', 'name' => "Sample Group"),
//    );
  return null;
  }

  public function list_records($cols=null, $subset=0)
  {
    $Contacts_folder = "Contacts";
    $rcmail = rcmail::get_instance();
    $id = $rcmail->user->get_username();
//    $this->headers = $this->imap->get_message($uid);
  $con = $rcmail->imap_connect();
   $rcmail->imap_init();
global $IMAP;
$IMAP->set_mailbox("Inbox.Contacts");

    $inbx = $IMAP->get_mailbox_name();
    $n = $IMAP->messagecount();
    $mbx = $IMAP->message_index($inbx,NULL);
//    $body = $IMAP->get_raw_body($uid);
//    $hdr = $IMAP->get_raw_headers($uid);
//
//    $this->result = $this->count();
//    $this->result->add(array('ID' => '111', 'name' => $n, 'firstname' => $uid, 'surname' => $hdr, 'email' => $mbx[1]));
//    $this->result = $n;
 $this->result =$this->count();

    $this->result->count=0;
     $start_row = $this->vlv_active ? 0 : $this->result->first;
             $start_row = $subset < 0 ? $start_row + $this->page_size + $subset : $start_row;
             $last_row = $this->result->first + $this->page_size;
            $last_row = $subset != 0 ? $start_row + abs($subset) : $last_row;
    for($count=0;$count<$n;$count++)
//    for($count=$start_row;$count<$last_row;$count++)
    {
    $uid = $IMAP->get_uid($mbx[$count],$inbx);
    $body = $IMAP->get_message_part($uid, 2);

    $contact[$count]= $this->parsexml($body,$uid);
//    $this->result->add($contact[$count]);
  // $this->result->add(array('ID' => $count, 'name' => $displaynume, 'firstname' => $nume, 'surname' => $prenume, 'email' => $email, 'mobile' => $telefon));
    $this->result->count++;

    }

    usort($contact, array($this, '_entry_sort_cmp'));

     $start_row = $this->vlv_active ? 0 : $this->result->first;
             $start_row = $subset < 0 ? $start_row + $this->page_size + $subset : $start_row;
             $last_row = $this->result->first + $this->page_size;
            $last_row = $subset != 0 ? $start_row + abs($subset) : $last_row;
    for($count=$start_row;$count<$last_row;$count++)
    {
     $this->result->add($contact[$count]);
  //
//      $this->result->count++;
    }
    
    return $this->result;
  }

 public function search($fields, $value, $strict=false, $select=true, $nocount=false, $required=array())
  {
    // no search implemented, just list all records
    return $this->list_records();
  }
 /* function search($fields, $value, $mode=0, $select=true, $nocount=false, $required=array())
      {
          $mode = intval($mode);
              
                      // special treatment for ID-based search
                              if ($fields == 'ID' || $fields == $this->primary_key)
                                      {
     $ids = !is_array($value) ? explode(',', $value) : $value;
     $result = new rcube_result_set();
     foreach ($ids as $id)
          {
          if ($rec = $this->get_record($id, true))
                      {
                      $result->add($rec);
                    $result->count++; 
                    }
    	}
    	}
                     return $result;
         }
         
         */
         
public function count()
  {

    return new rcube_result_set(40, ($this->list_page-1) * $this->page_size);
  }

  public function get_result()
  {
    return $this->result;
  }

  public function get_record($id, $assoc=false)
  {
    $this->list_records();
    $first = $this->result->first();
    $sql_arr = $first['ID'] == $id ? $first : null;
    global $IMAP;

    $body = $IMAP->get_message_part($id, 2);

    $res= $this->parsexml($body,$id);
    $this->result = new rcube_result_set(1);
    $this->result->add($res);
    return $assoc  ? $res : $this->result;
  }


  function create_group($name)
  {
    $result = false;

    return $result;
  }

  function delete_group($gid)
  {
    return false;
  }

  function rename_group($gid, $newname)
  {
    return $newname;
  }

  function add_to_group($group_id, $ids)
  {
    return false;
  }

  function remove_from_group($group_id, $ids)
  {
     return false;
  }
    private   function parsexml($rec,$id)
    {
    $p = xml_parser_create();
//    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
//        xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    $out=array('phone'=>array());
    $out["ID"]=$id;

    xml_parse_into_struct($p,$rec,$vals,$index);

    xml_parser_free($p);
    
    $ind=$index["DISPLAY-NAME"][0];
    $out["name"]=$vals[$ind]["value"];
    $ind=$index["LAST-NAME"][0];
  $out["firstname"]=$vals[$ind]["value"];

  $ind=$index["NUMBER"][0];
    $out["mobile"]=$vals[$ind]["value"];
    $out["phone"][0]=$vals[$ind]["value"];

    $ind=$index["GIVEN-NAME"][0];
    $out["surname"]=$vals[$ind]["value"];
    $ind=$index["SMTP-ADDRESS"][0];
    $out["email"]=$vals[$ind]["value"];
   $out["department"]=$out["phone"];
    return $out;
    }
    private function _entry_sort_cmp($a, $b)
    {
            return strcmp(strtolower($a[$this->sort_col][0]),strtolower( $b[$this->sort_col][0]));
    }

}
?>
